/************************************************************************
     File:        CubeIt.cpp
				  Useful 3D utilities for putting a few cubes into a world

				  These routines are used in the "CubeIt" tutorial programs,
				  and might be useful for student projects in CS559 as well.

     Author:     
                  Michael Gleicher, gleicher@cs.wisc.edu
     Modifier
                  Yu-Chi Lai, yu-chi@cs.wisc.edu
     
     Comment:     
		 
	 					    This program makes a simple 3D world with some cubes in it.
								It provides a user interface so that the user can select cubes
								and move them around. It also provides a basic user interface
								for the camera.
								
								This program is designed to serve as a starting platform for
								CS559 projects, or as reference for how to do different things.
								Remember: if you borrow code, you must give proper attribution!
								However, you are encouraged to borrow code from this
						
			Note:   i've built this to make it easy for me to make several
							different demos, so the code organization is kindof wierd
							i've had to put lots of common stuff here that you'd normally
							put into your window/widget class

              Written at October 2005
   
     Platform:    Visio Studio.Net 2003 (updated to VS2005)

     CVS Info: Date checked in: $Date: 2007/10/22 15:38:30 $
               Revision number: $Revision: 1.3 $

*************************************************************************/
#include "CubeIt.H"
#include "3DUtils.H"
#include <windows.h>
#include <GL/gl.h>

// for the Cheesy UI stuff
// the FlTk headers have lots of warnings - these are bad, but there's not
// much we can do about them
#pragma warning(push)
#pragma warning(disable:4311)		// convert void* to long
#pragma warning(disable:4312)		// convert long to void*
#pragma warning(pop)

//*********************************************************************************
//
// Keep a list of cubes to draw, remember which one is "selected"
//*********************************************************************************
std::vector<Cube> theCubes;
int selectedCube = -1;

//*********************************************************************************
//
// Note: this is hard coded for red cubes and yellow highlights
//=================================================================================
void drawCubes(int doColors, int doNames)
//=================================================================================
{
  // note: i am going to index through the array, rather than using an
  // iterator since I want to have the index
  for(int ct=0; ct< (int) theCubes.size(); ct++) {
	  if (doColors) {
		  if (selectedCube == ct)
			  glColor3f(1,1,0);
		  else
			  glColor3f(1,0,0);
	  }
	  if (doNames)
		  glLoadName(ct + 1);	// note: we don't use the name 0!
	  drawCube(theCubes[ct].x, theCubes[ct].y, theCubes[ct].z,
			   theCubes[ct].s);
  }
}



